//
//  bwQtMovieFile.h
//  ac3dec
//
//  Created by Brad Wright on Thu Jun 10 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Cocoa/Cocoa.h>
#import <QuickTime/QuickTime.h>

// Split movie into this many seconds
#define FILE_SPLIT_MINUTES (8)
#define FILE_SPLIT_SECONDS (FILE_SPLIT_MINUTES*60)
//#define FILE_SPLIT_SECONDS 3
#define AUDIO_BUFFER_SECONDS (30)
#define AUDIO_FRAME_SIZE  (4)
#define MAX_AUDIO_SAMPLE_RATE (48000)
#define AUDIO_BUFFER_SIZE (AUDIO_BUFFER_SECONDS * AUDIO_FRAME_SIZE * MAX_AUDIO_SAMPLE_RATE)

enum 
{
	BW_QTFILE_NORMAL_MODE,
	BW_QTFILE_SPLIT_MODE
};

enum
{
	BQT_NORMAL_STATE,
	BQT_STATE_WAIT_FOR_AUDIO,
	BQT_STATE_BUFFER_AUDIO_TO_MATCH_VIDEO,
};

@interface bwQtMovieFile : NSObject {
short resRefNum,PrevResRefNum;
Track theVideoTrack,thePrevVideoTrack,theDstTrack,thePrevDstTrack;
FSSpec mySpec;
struct FSCatalogInfo _fsinfo;
Media	theDstMedia,theVideoMedia,thePrevDstMedia,thePrevVideoMedia;
Movie theMovie,thePrevMovie;
SampleDescriptionHandle mySoundDesc;
int movieTimeScale;
int mySampleRate;
double _fsampleRate;
long double videoTime,thePrevVideoTime;
long double audioTime,thePrevAudioTime;
Rect myCropRect;
int splitNumber;
int mode; // normal mode or file split
NSString* movieFileString;
int state;
unsigned long audio_buffer_count;
//unsigned long audio_buffer_frame_count;
unsigned long audio_frame_length;
id myLock;


//Quicktime Time code stuff
Str255					gSrcName;
//Str255					gFontName;						// name of current font
//long					gFontIndex = 1;					// index in font pop-up menu of current font
//TimeScale				gTimeScale;// = 2997;				// typical for NTSC video (29.97 frames/sec)
TimeValue				gFrameDur; // = 100;				// duration of a single frame
long					gNumFrames;//s = 30;				// frames per second
Boolean					gDisplayTimeCode;// = false;
Boolean					gDisplayBelowVideo;// = true;
Boolean					gDropFrameVal;// = true;
Boolean					g24Hour;// = true;
Boolean					gNegOK;// = false;
Boolean					gIsNeg;// = false;
Boolean					gUseTimeCode;// = true;			// ue timecode (true) or counter (false)?
long					gHours;// = 0;
long					gMinutes;// = 10;
long					gSeconds;// = 5;
long					gFrames;// = 0;
long					gCounterVal;// = 0;
//UserItemUPP				gOptionsUserItemProcUPP;// = NULL;	// UPP to our options dialog user item procedure

}

-init;
+ (BOOL) getVideoSampleDescriptionForCodec:(unsigned long) codecType;
-(long double) calcAbufferTime;
- (void) setFileMode:(int) _mode;
-(void) setSaveFileString:(NSString*) _saveFile;
//-(void)InternalWriteSound:(char*)p_buffer theFrames:(int)numFrames theLen:(int)len theMediaTrack:(Media) theMedia;
-createMovie:(Rect) cropRect theTimeScale:(TimeScale) timeScale;
-createSoundTrack:(SampleDescriptionHandle)hSoundDescription theSampleRate:(int) _sampleRate;
- writeSound:(char*)p_buffer theFrames:(int)numFrames theLen:(int)len;
- addVideoSample:(int) dataSize theCompData:(Handle) compressedData 
	theImageDesc:(SampleDescriptionHandle) imageDesc theSampleTime:(TimeValue) sampleTime theDuration:(int) tmpDur;
-addVideoSample2:(int) dataSize theCompData:(Handle) compressedData 
	theImageDesc:(SampleDescriptionHandle) imageDesc theSampleTime:(TimeValue) sampleTime theDuration:(int) tmpDur syncSample:(BOOL) syncSample;

-(void) closeVideo;
-(void) closeAudio;
- (void) setTimeCode:(long) _gHours theMinutes:(long)_gMinutes theSeconds:(long) _gSeconds theFrames:(long) _gFrames dropFrameCode:(long) useDropFrame;
@end
