/*
 * mpeg2dec.h
 * Copyright (C) 2002 Shoji Tokunaga <toku@mac.com>
 *
 * This file is part of mpeg2decX, a free MPEG-2 video stream decoder.
 * See http://homepage1.nifty.com/~toku/software_en.html for updates.
 * (http://homepage1.nifty.com/~toku/software.html in Japanese)
 *
 * mpeg2decX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * mpeg2decX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//#import <Foundation/Foundation.h>
#include "video_out.h"
#define DONT_USE_APPCONTROLLER

#ifdef DONT_USE_APPCONTROLLER
#else
@class AppController;
#endif

enum {
    stNONE = 0,
    stDOING = 1,
    stWAITING = 2,
    stDONE = 3,
    stERROR = 4,
    stCANCEL = 5};

enum {
    formPREV = 0,
    formQT = 1};

extern int demux_track;
extern int demux_pid;
extern int disable_accel;
extern vo_open_t *output_open;
#ifdef DONT_USE_APPCONTROLLER
#else
extern AppController *gSelf;
#endif
extern int gFormat;

void setFileName(const char *name, int form);
void setAbort(int abort);
int getAbort(void);
void setDemuxTrack(int track);
void setSubPicID(int enable, int id);
void writeMessage(char *str);
void pauseOn(void);
void pauseOff(void);
unsigned int getPts(void);
unsigned int getSpcPts(void);

int mpeg2dec_main(void);
