//
//  mpegdecode.h
//  ac3dec
//
//  Created by Brad Wright on Wed Jun 11 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#ifdef VEESCOPE_COMPATIBLE_CODE
#else
#import <mpeg2qtOut.h>
#endif
#include "video_out.h"
#include "mpeg2.h"
#include "mpeg2_internal.h"
#include "mm_accel.h"
#define DONT_USE_APPCONTROLLER
#ifdef DONT_USE_APPCONTROLLER
#else
#import "AppController.h"
#endif
//#include "mpeg2dec.h"
#include "QuickTimeCode.h"
#include "SubPicture.h"
#include "bwDecodeCommon.h"
#ifndef USING_BW_BUNCH_ALT
#include "bwBunchaVideo.h"
#else
#import "bwAlternativeBunchaVideo.h"
#endif
#ifdef VEESCOPE_COMPATIBLE_CODE
#import <VeescopeQTMovieOutput.h>
#endif

@interface mpegdecode : NSObject 
{
    FSSpec *mySpec;
    mpeg2dec_t * _local_mpeg2dec;
    vo_open_t * output_open;
    vo_instance_t * output;
    // display settings.
    unsigned long set_display;
    unsigned long set_field;
    unsigned long set_fields;
    unsigned long set_iframe;
    unsigned long pixel_width;
    unsigned long pixel_height;
    unsigned long width;
    unsigned long height;
    unsigned long duration;
    unsigned long num_fields;
    unsigned long field_dominance;
    int _decode_settings;
    // Movie output object
    int duration_set_flag;
    id myWriteQueue;
    int readLoopInitFlag;
	id myBufferLock;
#ifdef USE_ALTERNATIVE_BUNCHA_VIDEO
	bwBunchaVideo* myBunchaVideoPtr;
#endif
@public
#ifdef VEESCOPE_COMPATIBLE_CODE
	VeescopeQTMovieOutput* qtMovieOutput;
#else
	mpeg2qtOut* qtMovieOutput;
#endif
}

- init;
- open;
- close;
- set_decode:(int) _setting;
-(int) get_decode;
- set_filespec:(FSSpec *) _spec;
- (int)video_info_found;
- createFile;
- displayPreview;
- notifyFrameDealloc;
- reset_scan_for_info;
-(int) checkForFrames:(unsigned char*) _buffer theSize:(unsigned long) _size;
- scan:(unsigned char*) _buffer theSize:(unsigned long) _size;
- writeRemainingTime;
- write:(unsigned char*) _buffer theSize:(unsigned long) _size;
//- decode:(unsigned char*) _buffer theSize:(unsigned long) _size;
- decode:(bwBunchaVideo*) _bunchaVideo;
- decodeBunch:(unsigned char*) _buffer theSize:(unsigned long) _size;
- addVideoSample:(unsigned char*) _frame thePts:(int)_pts theFieldDominance:(int) field_dom
	theRepeatFirstFieldFlag:(int) repeat_first_field;
-(unsigned int) checkError;
- closeMovie;
- (long double) getFrameDuration;
@end
